Attribute VB_Name = "basGraph"
Option Explicit

Public Const ciGraphPhys        As Integer = 1
Public Const ciGraphSens        As Integer = 2
Public Const ciGraphIntel       As Integer = 4
Public Const ciGraphCaut        As Integer = 8

Public Type RECT
    Left        As Long
    Top         As Long
    Right       As Long
    Bottom      As Long
End Type

Private mlForeColor     As Long         ' OiF
Private mlBackColor     As Long         ' wiF
Private mlBirthColor(3) As Long         ' ǵ^^m\F
Private mbEscDraw       As Boolean      ' `tO
                                        ' True= `, False= `撆~

Public Declare Function GetClientRect Lib "USER32" (ByVal hWnd&, lpRect As RECT) As Long

Public Property Let brEscDraw(ByVal pbEscDraw As Boolean)
'---------------------------------------------------------------------------
'    : brEscDraw()
' @@@\ : `撆~̐ݒ
' @@ : (I) pbEscDraw      `tO
'   l : Ȃ
' @@ : 1999/11/30
'---------------------------------------------------------------------------
    mbEscDraw = pbEscDraw
End Property

Public Sub brGraphDraw(ByVal pfMain As Form, ByVal pbDispFlag As Boolean)
'---------------------------------------------------------------------------
'    : brGraphDraw()
' @@@\ : oCIY\
' @@ : (I) pfMain         tH[
'          : (I) pbDispFlag     \tO
'   l : Ȃ
' @@ : 1999/11/25
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long         ' [vJE^
    Dim llDataCnt       As Long         ' \f[^
    Dim llWidth         As Long         ' `敝
    Dim llHeight        As Long         ' `捂
    Dim lsToolTip       As String       ' a
    Dim lsFormatStr     As String       ' NtH[}bg

    If pbDispFlag = False Then
        Exit Sub
    End If

    On Error GoTo brGraphDraw_Error

    mbEscDraw = True
    mlForeColor = brGetColor(basParam.brParamValue(csGraphFore))
    mlBackColor = brGetColor(basParam.brParamValue(csGraphBack))
    mlBirthColor(0) = brGetColor(basParam.brParamValue(csGraphPhys))
    mlBirthColor(1) = brGetColor(basParam.brParamValue(csGraphSens))
    mlBirthColor(2) = brGetColor(basParam.brParamValue(csGraphIntel))

    pfMain.picGraph.BackColor = mlBackColor

    llDataCnt = basParam.brGetBirthNum
    llWidth = pfMain.picGraph.Width
    llHeight = pfMain.picGraph.Height / llDataCnt

    If basParam.brParamValue(csBirthYear) <> False Then
        If basParam.brParamValue(csCalendar) = 0 Then
            lsFormatStr = "yy/m/d"
        Else
            lsFormatStr = "ge/m/d"
        End If
    Else
        lsFormatStr = "m/d"
    End If

    For llLoopCnt = 1 To llDataCnt
        If mbEscDraw <> False Then
            brSubGraphDraw pfMain, pfMain.picGraph, "", llHeight * (llLoopCnt - 1), llWidth, llHeight, basParam.brBirthDay(llLoopCnt), llLoopCnt, llDataCnt
        End If
        lsToolTip = lsToolTip & " (" & llLoopCnt & ")" & basParam.brUserName(llLoopCnt) & "[" & Format(basParam.brBirthDay(llLoopCnt), lsFormatStr) & "]"
    Next llLoopCnt
    pfMain.picGraph.ToolTipText = lsToolTip & " "

    mbEscDraw = False
    Exit Sub

brGraphDraw_Error:
    mbEscDraw = False
    Resume Next
End Sub

Public Sub brGraphPrint(ByVal pfMain As Form, ByVal plOrientation As Long)
'---------------------------------------------------------------------------
'    : brGraphPrint()
' @@@\ : oCIY
' @@ : (I) pfMain         tH[
'          : (I) plOrientation  
'   l : Ȃ
' @@ : 1999/12/01
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long         ' [vJE^
    Dim llDataCnt       As Long         ' \f[^
    Dim llWidth         As Long         ' `敝
    Dim llHeight        As Long         ' `捂
    Dim lsToolTip       As String       ' a
    Dim lsFormatStr     As String       ' NtH[}bg
    Dim ldPrintRate     As Double       ' vgg^k

    DoEvents
    mlForeColor = brGetColor(basParam.brParamValue(csGraphFore))
    mlBackColor = brGetColor(basParam.brParamValue(csGraphBack))
    mlBirthColor(0) = brGetColor(basParam.brParamValue(csGraphPhys))
    mlBirthColor(1) = brGetColor(basParam.brParamValue(csGraphSens))
    mlBirthColor(2) = brGetColor(basParam.brParamValue(csGraphIntel))

    llDataCnt = basParam.brGetBirthNum
    If plOrientation = vbPRORPortrait Then
        llWidth = 11520
        llHeight = 15360
    Else
        llWidth = 15360
        llHeight = 11520
    End If
    ldPrintRate = basParam.brParamValue(csPrintRate) / 100
    llWidth = llWidth * ldPrintRate
    llHeight = (llHeight * ldPrintRate) / llDataCnt

    If basParam.brParamValue(csBirthYear) <> False Then
        If basParam.brParamValue(csCalendar) = 0 Then
            lsFormatStr = "yy/m/d"
        Else
            lsFormatStr = "ge/m/d"
        End If
    Else
        lsFormatStr = "m/d"
    End If

    For llLoopCnt = 1 To llDataCnt
        lsToolTip = "(" & llLoopCnt & ")" & basParam.brUserName(llLoopCnt) & "[" & Format(basParam.brBirthDay(llLoopCnt), lsFormatStr) & "]"
        brSubGraphDraw pfMain, Printer, lsToolTip, llHeight * (llLoopCnt - 1), llWidth, llHeight, basParam.brBirthDay(llLoopCnt), llLoopCnt, llDataCnt
    Next llLoopCnt

End Sub

Private Sub brSubGraphDraw(ByVal pfMain As Form, ByVal ppDrawCtrl As Control, _
    ByVal psToolTip As String, ByVal plTop As Long, ByVal plWidth As Long, ByVal plHeight As Long, _
    ByVal pdBirthDay As Date, ByVal plDataIndex As Long, ByVal plDataCnt As Long)
'---------------------------------------------------------------------------
'    : brGraphDraw()
' @@@\ : oCIY\iTuj
' @@ : (I) pfMain         tH[
'          : (I) plTop          `Jnʒu
'          : (I) plWidth        `敝
'          : (I) plHeight       `捂
'          : (I) pdBirthDay     a
'   l : Ȃ
' @@ : 1999/11/01
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long         ' [vJE^
    Dim liBrthCnt       As Integer      ' ǵ^^m[vJE^
    Dim liCenter        As Integer      ' ̈ʒu
    Dim liMrgWidth      As Integer      ' }[W
    Dim liMrgHeight     As Integer      ' }[W
    Dim llDispPnt       As Long         ' \
    Dim llDispStart     As Long         ' \Jn
    Dim llDispEnd       As Long         ' \I
    Dim liCycle(3)      As Integer      ' TCN
    Dim liNowPnt        As Integer      ' \|Cg
    Dim llFromPosX      As Long         ' wẄʒu
    Dim llFromPosY      As Long         ' xẄʒu
    Dim llToPosX        As Long         ' wẄʒu
    Dim llToPosY        As Long         ' xẄʒu
    Dim ldScaleX        As Double       ' wWXP[
    Dim ldScaleY        As Double       ' xWXP[
    Dim ldMaxPoint      As Double       ' őOtl
    Dim ldMinPoint      As Double       ' ŏOtl
    Dim lsDispStr       As String       ' \
    Dim lsFormatStr     As String       ' NtH[}bg
    Dim liCircleSize    As Integer      ' ~̑傫
    Dim llDateBase      As Long         ' \Jn
    Dim lbFullDay       As Boolean      ' ڍׂȓt\

    ' Kl̏
    liMrgWidth = 300
    liMrgHeight = 280
    llDispPnt = basParam.brParamValue(csDispDay) - pdBirthDay
    llDispStart = llDispPnt - basParam.brParamValue(csDispPeriod)
    llDispEnd = llDispPnt + basParam.brParamValue(csDispPeriod)
    liCycle(0) = ciPhysCycle * ciInterval
    liCycle(1) = ciSensCycle * ciInterval
    liCycle(2) = ciIntelCycle * ciInterval
    ldMaxPoint = 1
    ldMinPoint = -1
    liCircleSize = 55

    ' ڐ̕`
    With ppDrawCtrl
        .DrawMode = basParam.brParamValue(csDrawMode)
        .Font = "lr SVbN"
        .FontSize = 9
        liCenter = (plHeight / 2) + plTop
'        .BackColor = mtGraphInfo.lBack
        .DrawWidth = 1
        .ForeColor = mlForeColor
        ppDrawCtrl.Line (liMrgWidth, liCenter)-(plWidth - liMrgWidth, liCenter), mlForeColor
        ppDrawCtrl.Line (liMrgWidth, liMrgHeight + plTop)-(liMrgWidth, (plHeight - liMrgHeight + plTop)), mlForeColor

        If plDataIndex = 1 Then
            .ForeColor = mlBirthColor(0)
            ppDrawCtrl.Line ((plWidth - liMrgWidth) - 1500, .TextHeight("0") + 10 + plTop)-((plWidth - liMrgWidth) - 1400, 10 + plTop), , BF
            .CurrentX = .CurrentX + 50
            ppDrawCtrl.Print ""
            .ForeColor = mlBirthColor(1)
            ppDrawCtrl.Line ((plWidth - liMrgWidth) - 1100, .TextHeight("0") + 10 + plTop)-((plWidth - liMrgWidth) - 1000, 10 + plTop), , BF
            .CurrentX = .CurrentX + 50
            ppDrawCtrl.Print ""
            .ForeColor = mlBirthColor(2)
            ppDrawCtrl.Line ((plWidth - liMrgWidth) - 700, .TextHeight("0") + 10 + plTop)-((plWidth - liMrgWidth) - 600, 10 + plTop), , BF
            .CurrentX = .CurrentX + 50
            ppDrawCtrl.Print "m"
            .ForeColor = mlForeColor
            .FillStyle = vbFSTransparent
            ppDrawCtrl.Circle ((plWidth - liMrgWidth) - 250, .TextHeight("0") / 2 + plTop), liCircleSize
            .CurrentX = .CurrentX + 100
            .CurrentY = 10 + plTop
            ppDrawCtrl.Print ""
        End If

        If plDataIndex = plDataCnt Then
            If basParam.brParamValue(csCalendar) = 0 Then
                lsFormatStr = "yy/m/d"
            Else
                lsFormatStr = "ge/m/d"
            End If
            lsDispStr = Format(basParam.brParamValue(csDispDay) - basParam.brParamValue(csDispPeriod), lsFormatStr)
            .CurrentX = liMrgWidth
            .CurrentY = plHeight - liMrgHeight + plTop
            ppDrawCtrl.Print lsDispStr
            ppDrawCtrl.Line (plWidth - liMrgWidth, liMrgHeight + plTop)-(plWidth - liMrgWidth, (plHeight - liMrgHeight + plTop)), mlForeColor
            lsDispStr = Format(basParam.brParamValue(csDispDay) + basParam.brParamValue(csDispPeriod), lsFormatStr)
            .CurrentX = .CurrentX - .TextWidth(lsDispStr)
            ppDrawCtrl.Print lsDispStr
'            .DrawStyle = vbDot
            ppDrawCtrl.Line (plWidth / 2, liMrgHeight + plTop)-(plWidth / 2, (plHeight - liMrgHeight + plTop)), mlForeColor
'            .DrawStyle = vbSolid
            lsDispStr = Format(basParam.brParamValue(csDispDay), lsFormatStr)
            .CurrentX = .CurrentX - .TextWidth(lsDispStr) / 2
            ppDrawCtrl.Print lsDispStr
        Else
            ppDrawCtrl.Line (plWidth - liMrgWidth, liMrgHeight + plTop)-(plWidth - liMrgWidth, (plHeight - liMrgHeight + plTop)), mlForeColor
            ppDrawCtrl.Line (plWidth / 2, liMrgHeight + plTop)-(plWidth / 2, (plHeight - liMrgHeight + plTop)), mlForeColor
        End If

        .ForeColor = mlForeColor
        lsDispStr = ""
        .CurrentX = liMrgWidth - .TextWidth(lsDispStr)
        .CurrentY = liMrgHeight + plTop
        ppDrawCtrl.Print lsDispStr
        lsDispStr = ""
        .CurrentX = liMrgWidth - .TextWidth(lsDispStr)
        .CurrentY = liCenter - .TextHeight(lsDispStr) / 2
        ppDrawCtrl.Print lsDispStr
        lsDispStr = ""
        .CurrentX = liMrgWidth - .TextWidth(lsDispStr)
        .CurrentY = plHeight - liMrgHeight + plTop - .TextHeight(lsDispStr)
        ppDrawCtrl.Print lsDispStr

        .CurrentX = liMrgWidth - .TextWidth("")
        .CurrentY = 25 + plTop
'        If psToolTip = "" Then
            liCircleSize = 55
'        Else
'            liCircleSize = 20
'        End If
        If basParam.brParamValue(csDispTotal) <> False Then
            If llDispPnt >= 0 Then
                psToolTip = psToolTip & " " & llDispPnt & " "
            Else
                psToolTip = psToolTip & "O " & Abs(llDispPnt) & " "
            End If
        End If
        ppDrawCtrl.Print psToolTip
    End With

    ' t
    If basParam.brParamValue(csDayLine) <> False Then
        With ppDrawCtrl
            ldScaleX = (plWidth - (liMrgWidth * 2)) / (llDispEnd - llDispStart)
            ldScaleY = (plHeight - (liMrgHeight * 2)) / (ldMaxPoint - ldMinPoint)
            .ForeColor = mlForeColor
            .DrawStyle = vbDot
            .DrawWidth = 1
            lbFullDay = basParam.brParamValue(csFullDay)
            If lbFullDay <> False Then
                llDateBase = basParam.brParamValue(csDispDay) - basParam.brParamValue(csDispPeriod)
                For llLoopCnt = llDispStart + 1 To llDispStart + basParam.brParamValue(csDispPeriod) - 1
                    llToPosX = liMrgWidth + ldScaleX * (llLoopCnt - llDispStart)
                    llToPosY = plHeight - liMrgHeight + plTop - (.TextHeight(lsDispStr) + .TextHeight(lsDispStr) * (llLoopCnt Mod 2))

                    lsDispStr = Format(llDateBase + (llLoopCnt - llDispStart), "d")
                    .CurrentX = llToPosX - (.TextWidth(lsDispStr) / 2)
                    .CurrentY = llToPosY
                    ppDrawCtrl.Print lsDispStr

                    ppDrawCtrl.Line (llToPosX, liMrgHeight + 100 + plTop)-(llToPosX, llToPosY), mlForeColor
                Next llLoopCnt
                For llLoopCnt = llLoopCnt + 1 To llDispEnd - 1
                    llToPosX = liMrgWidth + ldScaleX * (llLoopCnt - llDispStart)
                    llToPosY = plHeight - liMrgHeight + plTop - (.TextHeight(lsDispStr) + .TextHeight(lsDispStr) * (llLoopCnt Mod 2))

                    lsDispStr = Format(llDateBase + (llLoopCnt - llDispStart), "d")
                    .CurrentX = llToPosX - (.TextWidth(lsDispStr) / 2)
                    .CurrentY = llToPosY
                    ppDrawCtrl.Print lsDispStr

                    ppDrawCtrl.Line (llToPosX, liMrgHeight + 100 + plTop)-(llToPosX, llToPosY), mlForeColor
                Next llLoopCnt
            Else
                For llLoopCnt = llDispStart + 1 To llDispStart + basParam.brParamValue(csDispPeriod) - 1
                    llToPosX = liMrgWidth + ldScaleX * (llLoopCnt - llDispStart)
                    ppDrawCtrl.Line (llToPosX, liMrgHeight + 100 + plTop)-(llToPosX, (plHeight - liMrgHeight - 100 + plTop)), mlForeColor
                Next llLoopCnt
                For llLoopCnt = llLoopCnt + 1 To llDispEnd - 1
                    llToPosX = liMrgWidth + ldScaleX * (llLoopCnt - llDispStart)
                    ppDrawCtrl.Line (llToPosX, liMrgHeight + 100 + plTop)-(llToPosX, (plHeight - liMrgHeight - 100 + plTop)), mlForeColor
                Next llLoopCnt
            End If
            .DrawStyle = vbSolid
        End With
    End If

    ' vӓ
    llDispStart = llDispStart * ciInterval
    llDispEnd = llDispEnd * ciInterval
    ldScaleX = (plWidth - (liMrgWidth * 2)) / (llDispEnd - llDispStart)
    ldScaleY = (plHeight - (liMrgHeight * 2)) / (ldMaxPoint - ldMinPoint)
    If pfMain.mnuViewSelectGraph(3).Checked = True Then
        With ppDrawCtrl
            .ForeColor = mlForeColor
            .FillStyle = vbFSSolid
            .DrawWidth = 1
            For llLoopCnt = llDispStart To llDispEnd Step ciInterval
                llToPosY = liMrgHeight + plTop
                For liBrthCnt = 0 To 2
                    liNowPnt = llLoopCnt Mod liCycle(liBrthCnt)
                    Do While liNowPnt < 0
                        liNowPnt = liNowPnt + liCycle(liBrthCnt)
                    Loop
                    If (gdBrthTable(liBrthCnt, liNowPnt) > -0.15 And gdBrthTable(liBrthCnt, liNowPnt) < 0.15) Then
                        .FillColor = mlBirthColor(liBrthCnt)
                        llToPosX = liMrgWidth + ldScaleX * (llLoopCnt - llDispStart)
                        ppDrawCtrl.Circle (llToPosX, llToPosY), liCircleSize
                        llToPosY = llToPosY + (liCircleSize * 2)
                    End If
                Next liBrthCnt
            Next llLoopCnt
        End With
    End If

    ' oCIY
    For liBrthCnt = 0 To 2
        If pfMain.mnuViewSelectGraph(liBrthCnt).Checked = True Then
            With ppDrawCtrl
                .ForeColor = mlBirthColor(liBrthCnt)
                .DrawWidth = basParam.brParamValue(csLineWidth)
                For llLoopCnt = llDispStart To llDispEnd Step basParam.brParamValue(csGraphPoint)
                    liNowPnt = llLoopCnt Mod liCycle(liBrthCnt)
                    Do While liNowPnt < 0
                        liNowPnt = liNowPnt + liCycle(liBrthCnt)
                    Loop
                    llToPosX = liMrgWidth + ldScaleX * (llLoopCnt - llDispStart)
                    llToPosY = liMrgHeight + (ldMaxPoint - gdBrthTable(liBrthCnt, liNowPnt)) * ldScaleY + plTop
                    If llLoopCnt <> llDispStart Then
                        ppDrawCtrl.Line (llFromPosX, llFromPosY)-(llToPosX, llToPosY), mlBirthColor(liBrthCnt)
                    End If
                    llFromPosX = llToPosX
                    llFromPosY = llToPosY
                Next llLoopCnt
            End With
        End If
    Next liBrthCnt
    DoEvents
End Sub

Public Sub brSaveGraphPoint(ByVal psFileName As String)
'---------------------------------------------------------------------------
'    : brSaveGraphPoint()
' @@@\ : Ot̏o
' @@ : (I) psFileName     t@C
'   l : Ȃ
' @@ : 2001/12/15
'---------------------------------------------------------------------------
    Dim llLoopCnt       As Long         ' [vJE^
    Dim llDatLoop       As Long         ' o͐l[vJE^
    Dim liBrthCnt       As Integer      ' ǵ^^m[vJE^
    Dim llStepNum       As Long         ' o̓|Cg
    Dim liRetCode       As Integer      ' ߂l
    Dim llDataCnt       As Long         ' \f[^
    Dim lsFormatStr     As String       ' NtH[}bg
    Dim liFileNo        As Integer      ' t@Cԍ
    Dim lsDelimChar     As String       ' ؂蕶
    Dim llPutPeriod     As Long         ' o͊
    Dim llPutPnt        As Long         ' o͓
    Dim llPutStart      As Long         ' o͊Jn
    Dim llPutEnd        As Long         ' o͏I
    Dim liCycle(3)      As Integer      ' TCN
    Dim liNowPnt        As Integer      ' \|Cg
    Dim ldPutDay        As Date         ' o͓

    On Error GoTo brSaveGraphPoint_Error

    liFileNo = FreeFile
    llStepNum = basParam.brParamValue(csGraphPoint)
    lsDelimChar = ","   ' basParam.brParamValue(csDelimChar)
    liCycle(0) = ciPhysCycle * ciInterval
    liCycle(1) = ciSensCycle * ciInterval
    liCycle(2) = ciIntelCycle * ciInterval
    llPutPeriod = basParam.brParamValue(csDispPeriod)
    llDataCnt = basParam.brGetBirthNum
    ldPutDay = basParam.brParamValue(csDispDay)
    If basParam.brParamValue(csBirthYear) <> False Then
        If basParam.brParamValue(csCalendar) = 0 Then
            lsFormatStr = "yyyy/m/d"
        Else
            lsFormatStr = "ge/m/d"
        End If
    Else
        lsFormatStr = "m/d"
    End If

    Open psFileName For Output Access Write As liFileNo
    Print #liFileNo, "o͓" & lsDelimChar & Format(ldPutDay - llPutPeriod, lsFormatStr) & lsDelimChar & Format(ldPutDay + llPutPeriod, lsFormatStr)
    For llDatLoop = 1 To llDataCnt
        Print #liFileNo, "O" & lsDelimChar & brbChangeString2Csv(basParam.brUserName(llDatLoop), lsDelimChar)
        Print #liFileNo, "a" & lsDelimChar & Format(basParam.brBirthDay(llDatLoop), lsFormatStr)

        llPutPnt = ldPutDay - basParam.brBirthDay(llDatLoop)
        llPutStart = (llPutPnt - llPutPeriod) * ciInterval
        llPutEnd = (llPutPnt + llPutPeriod) * ciInterval
        For liBrthCnt = 0 To 2
            For llLoopCnt = llPutStart To llPutEnd Step llStepNum
            liNowPnt = llLoopCnt Mod liCycle(liBrthCnt)
                Do While liNowPnt < 0
                    liNowPnt = liNowPnt + liCycle(liBrthCnt)
                Loop
                If llLoopCnt = llPutStart Then
                    Print #liFileNo, Format(gdBrthTable(liBrthCnt, liNowPnt), "0.#####");
                Else
                    Print #liFileNo, ",";
                    Print #liFileNo, Format(gdBrthTable(liBrthCnt, liNowPnt), "0.#####");
                End If
            Next llLoopCnt
            Print #liFileNo,
        Next liBrthCnt
    Next llDatLoop
    Close liFileNo

    Exit Sub

brSaveGraphPoint_Error:
    liRetCode = MsgBox("t@C݂̏Ɏs܂B" & vbCrLf & psFileName, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close liFileNo
End Sub

Public Function brGetColor(psBefColor As String)
'---------------------------------------------------------------------------
'    : brGetColor()
' @@@\ : F񕶎񂩂Fԍ擾
' @@ : (I) psBefColor     ϊF
'   l : Ȃ
' @@ : 1998/12/11
'---------------------------------------------------------------------------
    Dim llRed           As Long         ' Fiԁj
    Dim llGreen         As Long         ' Fi΁j
    Dim llBlue          As Long         ' Fij

    llRed = Val(Mid(psBefColor, 1, 3))
    llGreen = Val(Mid(psBefColor, 4, 3))
    llBlue = Val(Mid(psBefColor, 7, 3))

    brGetColor = RGB(llRed, llGreen, llBlue)
End Function

Public Function brPutColor(ByVal plColorValue As Long) As String
'---------------------------------------------------------------------------
'    : brPutColor()
' @@@\ : Ot\Fۑ
' @@ : (I) plColorValue   Fl
'   l : F̕
' @@ : 1999/07/15
'---------------------------------------------------------------------------
    Dim liBlue          As Integer      ' F
    Dim lsBlue          As String       ' F
    Dim liGreen         As Integer      ' ΐF
    Dim lsGreen         As String       ' ΐF
    Dim liRed           As Integer      ' ԐF
    Dim lsRed           As String       ' ԐF

    lsBlue = Hex(plColorValue And &HFF0000)
    lsBlue = Left("000000", 6 - Len(lsBlue)) & lsBlue
    lsBlue = "&H" & Left(lsBlue, 2)
    liBlue = lsBlue
    lsBlue = liBlue
    lsBlue = Left("000", 3 - Len(lsBlue)) & lsBlue
    lsGreen = Hex(plColorValue And &HFF00)
    lsGreen = Left("000000", 6 - Len(lsGreen)) & lsGreen
    lsGreen = "&H" & Mid(lsGreen, 3, 2)
    liGreen = lsGreen
    lsGreen = liGreen
    lsGreen = Left("000", 3 - Len(lsGreen)) & lsGreen
    lsRed = plColorValue And &HFF
    lsRed = Left("000", 3 - Len(lsRed)) & lsRed

    brPutColor = lsRed & lsGreen & lsBlue
End Function

Public Sub brSetWindowPos(ByVal pfForm As Form, ByVal pbStatus As Boolean)
'---------------------------------------------------------------------------
'    : brSetWindowPos()
' @@@\ : EBhEʒu̐ݒ
' @@ : (I) pbStatus       \ʒuiTrue= ɎO, False= ʏj
'   l : Ȃ
' @@ : 1999/11/20
'---------------------------------------------------------------------------
    Dim llRetCode       As Long         ' ߂l
    Dim liTwipX         As Integer      ' XP[[hϊ
    Dim liTwipY         As Integer      ' XP[[hϊ

    liTwipX = Screen.TwipsPerPixelX
    liTwipY = Screen.TwipsPerPixelY
    If pbStatus <> False Then
        llRetCode = SetWindowPos(pfForm.hWnd, HWND_TOPMOST, pfForm.Left \ liTwipX, pfForm.Top \ liTwipY, pfForm.Width \ liTwipX, pfForm.Height \ liTwipY, SWP_NOACTIVATE Or SWP_SHOWWINDOW)
    Else
        llRetCode = SetWindowPos(pfForm.hWnd, HWND_NOTOPMOST, pfForm.Left \ liTwipX, pfForm.Top \ liTwipY, pfForm.Width \ liTwipX, pfForm.Height \ liTwipY, SWP_NOACTIVATE Or SWP_SHOWWINDOW)
    End If
End Sub

Public Sub brSetTaskBar(ByVal pfMain As Form)
'---------------------------------------------------------------------------
'    : brSetTaskBar()
' @@@\ : ^XNo[̕\
' @@ : Ȃ
'   l : Ȃ
' @@ : 1999/11/25
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim lsUserName      As String       ' O

    For liLoopCnt = 1 To basParam.brGetBirthNum
        If lsUserName = "" Then
            lsUserName = basParam.brUserName(liLoopCnt)
        Else
            lsUserName = lsUserName & ", " & basParam.brUserName(liLoopCnt)
        End If
    Next liLoopCnt
    pfMain.Caption = "oCIY i" & lsUserName & "j"
End Sub

Public Sub brGraphDefColor(ByVal pfMain As Form)
'---------------------------------------------------------------------------
'    : brGraphDefColor()
' @@@\ : Ot\FWɖ߂
' @@ : (I) pfMain         tH[
'   l : Ȃ
' @@ : 1999/11/30
'---------------------------------------------------------------------------
    basParam.brParamValue(csGraphFore) = csDefGraphFore
    basParam.brParamValue(csGraphBack) = csDefGraphBack
    basParam.brParamValue(csGraphPhys) = csDefGraphPhys
    basParam.brParamValue(csGraphSens) = csDefGraphSens
    basParam.brParamValue(csGraphIntel) = csDefGraphIntel

    brGraphDraw pfMain, True
End Sub

Public Sub brResizeForm(ByVal pfMain As Form)
'---------------------------------------------------------------------------
'    : brResizeForm()
' @@@\ : oCIY\ʂ̃TCYύX
' @@ : (I) pfMain         tH[
'   l : Ȃ
' @@ : 1999/11/30
'---------------------------------------------------------------------------
    Dim llRetCode       As Long         ' ߂l
    Dim llWidth         As Long         ' EBhE
    Dim llHeight        As Long         ' EBhE
    Dim ltRect          As RECT         ' EBhETCY

    If pfMain.Width < 3200 Then
        pfMain.Width = 3200
    End If
    If pfMain.Height < 2000 Then
        pfMain.Height = 2000
    End If
    pfMain.Line1(0).X2 = pfMain.Width
    pfMain.Line1(1).X2 = pfMain.Width

    llRetCode = GetClientRect(pfMain.hWnd, ltRect)
    llWidth = (ltRect.Right - ltRect.Left) * 15
    llHeight = (ltRect.Bottom - ltRect.Top) * 15

    If basParam.brParamValue(csDateChange) <> False Then
        pfMain.picGraph.Top = 480
        pfMain.picGraph.Height = llHeight - 480
    Else
        pfMain.picGraph.Top = 120
        pfMain.picGraph.Height = llHeight - 130
    End If
    pfMain.picGraph.Width = llWidth - (10 * 2)
End Sub

Public Sub brInitForm(ByVal pfMain As Form)
'---------------------------------------------------------------------------
'    : brInitForm()
' @@@\ : oCIY\tH[\R[obN
' @@ : Ȃ
'   l : Ȃ
' @@ : 1999/11/01
'---------------------------------------------------------------------------
    Dim liLoopCnt       As Integer      ' [vJE^
    Dim liBitFlag(3)    As Integer      ' rbgZp
    liBitFlag(0) = ciGraphPhys
    liBitFlag(1) = ciGraphSens
    liBitFlag(2) = ciGraphIntel
    liBitFlag(3) = ciGraphCaut

    ' EBhE^
    pfMain.Left = basParam.brParamValue(csGraphPosX)
    pfMain.Top = basParam.brParamValue(csGraphPosY)
    pfMain.Width = Abs(basParam.brParamValue(csGraphWidth))
    pfMain.Height = Abs(basParam.brParamValue(csGraphHeight))

    ' ǵ^^m\
    For liLoopCnt = 0 To 3
        If (basParam.brParamValue(csGraphDisp) And liBitFlag(liLoopCnt)) = liBitFlag(liLoopCnt) Then
            pfMain.mnuViewSelectGraph(liLoopCnt).Checked = True
        End If
    Next liLoopCnt

    ' \؂ւ{^^j[
    pfMain.cmdChangeDate(1).Caption = basParam.brParamValue(csDispPeriod) & "O(&B)"
    pfMain.cmdChangeDate(2).Caption = basParam.brParamValue(csDispPeriod) & "(&A)"
    pfMain.mnuViewDateChange(1).Caption = basParam.brParamValue(csDispPeriod) & "O(&B)"
    pfMain.mnuViewDateChange(2).Caption = basParam.brParamValue(csDispPeriod) & "(&A)"

    If basParam.brParamValue(csDateChange) <> False Then
        pfMain.mnuViewDateButton.Checked = True
    End If
    For liLoopCnt = 0 To 2
        pfMain.cmdChangeDate(liLoopCnt).Visible = basParam.brParamValue(csDateChange)
    Next liLoopCnt

    ' ^XNo[
    brSetTaskBar pfMain

    ' ɎOɕ\̐ݒ
    brSetWindowPos pfMain, basParam.brParamValue(csAlwayTop)
End Sub
